/**************************************************************************************************/

/*
 * File: 
 * Author: Roman Lysecky
 * Date Created: 10 November 2011
 *
 * Description: 
 *
 * Copyright: 
 *
 */

/**************************************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "vertex.h"
#include "vlist.h"

/**************************************************************************************************/

/* initialize vlist to empty vlist */
void 
vlist_init(VertexList *vlist)
{
    if( vlist == NULL ) return;
    
    vlist->head = NULL;
    vlist->tail = NULL;
    vlist->size = 0;
}

/**************************************************************************************************/

/* destroy the vlist */
void 
vlist_destroy(VertexList *vlist)
{
    if( vlist == NULL ) return;
    
    /* while the list of list elements is not empty, remove the element at the head of the list */
    while( vlist->size > 0 ) {
        vlist_remove(vlist, vlist->head);
    }
}

/**************************************************************************************************/

/* inserts new vertex into vlist after the given vlist element, returns pointer to newly created
 * vertex is successful, NULL otherwise */
Vertex * 
vlist_insert_virtex(VertexList *vlist, int id)
{
    if( vlist == NULL ) return NULL;
    
    return vlist_insert_next(vlist, vlist->tail, id);
}

/**************************************************************************************************/

/* return pointer to vertex with specified id */
Vertex * 
vlist_lookup(VertexList *vlist, int id)
{
    if( vlist == NULL ) return NULL;

    return NULL;
}

/**************************************************************************************************/

/* removes the specified vertex from the vlist */
bool 
vlist_remove(VertexList *vlist, Vertex *vertex)
{
    if( vlist == NULL ) return FALSE;

    return FALSE;
}

/**************************************************************************************************/

/* inserts new vertex into vlist after the given vlist element */
Vertex * 
vlist_insert_next(VertexList *vlist, Vertex *vertex, int id)
{
    if( vlist == NULL ) return NULL;

    return NULL;
}

/**************************************************************************************************/

/* inserts new vertex into vlist before the given vlist element */
Vertex * 
vlist_insert_prev(VertexList *vlist, Vertex *vertex, int id)
{
    if( vlist == NULL ) return NULL;

    return NULL; 
}

/**************************************************************************************************/

