/**************************************************************************************************/

/*
 * File: 
 * Author: Roman Lysecky
 * Date Created: 10 November 2011
 *
 * Description: 
 *
 * Copyright: 
 *
 */

/**************************************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "edge.h"
#include "elist.h"

/**************************************************************************************************/

/* initialize elist to empty elist */
void 
elist_init(EdgeList *elist)
{
    if( elist == NULL ) return;
    
    elist->head = NULL;
    elist->tail = NULL;
    elist->size = 0;
}

/**************************************************************************************************/

/* destroy the elist */
void 
elist_destroy(EdgeList *elist)
{
    if( elist == NULL ) return;
    
    /* while the list of list elements is not empty, remove the element at the head of the list */
    while( elist->size > 0 ) {
        elist_remove(elist, elist->head);
    }
}

/**************************************************************************************************/

/* inserts new edge (Vertex *, weight) into elist */
bool 
elist_insert_edge(EdgeList *elist, Vertex *adjVirtex, int weight)
{
    if( elist == NULL ) return FALSE;

    return elist_insert_next(elist, elist->tail, adjVirtex, weight);
}

/**************************************************************************************************/

/* removes the specified edge from the vlist */
bool 
elist_remove(EdgeList *elist, Edge *edge)
{
    if( elist == NULL ) return FALSE;

    return FALSE;
}

/**************************************************************************************************/

/* inserts new vertex into vlist after the given vlist element */
bool 
elist_insert_next(EdgeList *elist, Edge *edge, Vertex *adjVirtex, int weight)
{
    if( elist == NULL ) return FALSE;

    return FALSE;
}

/**************************************************************************************************/

/* inserts new vertex into vlist before the given vlist element */
bool 
elist_insert_prev(EdgeList *elist, Edge *edge, Vertex *adjVirtex, int weight)
{
    if( elist == NULL ) return FALSE;

    return FALSE; 
}

/**************************************************************************************************/

