/**************************************************************************************************/


/*
 * File: 
 * Author: Roman Lysecky
 * Date Created: 10 November 2011
 *
 * Description: 
 *
 * Copyright: 
 *
 */

/**************************************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "graph.h"
#include "vlist.h"

/**************************************************************************************************/

/* initialize graph to empty graph */ 
void 
graph_init(Graph *graph)
{
    if( graph == NULL ) return;

    vlist_init(&(graph->vertices));
}

/**************************************************************************************************/

/* 
 * destroys the graph by destroying the list of vertices */
void 
graph_destroy(Graph *graph)
{
    if( graph == NULL ) return;

    vlist_destroy(&(graph->vertices));
}

/**************************************************************************************************/

