/**************************************************************************************************/

/*
 * File: 
 * Author: Roman Lysecky
 * Date Created: 10 November 2011
 *
 * Description: 
 *
 * Copyright: 
 *
 */

/**************************************************************************************************/

#include "global.h"
#include "vertex.h"
#include "edge.h"
#include "vlist.h"

/**************************************************************************************************/

#ifndef GRAPH_H
#define GRAPH_H

/**************************************************************************************************/

typedef struct Graph_ {
    VertexList vertices;
    int vcount;
    int ecount;
} Graph;

/**************************************************************************************************/

/* initialize graph to empty graph */
void graph_init(Graph *graph);

/* 
 * destroys the graph by freeing all memory allocated for each graph element returning the graph
 * to an empty graph
 */
void graph_destroy(Graph *graph);

/**************************************************************************************************/

#endif

/**************************************************************************************************/

